<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8">
<title>LibSylph: Sylph::Exception Class Reference</title>
<link href="doxygen.css" rel="stylesheet" type="text/css">
</head><body>
<!-- Generated by Doxygen 1.5.8 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li class="current"><a href="classes.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="classes.html"><span>Class&nbsp;Index</span></a></li>
      <li><a href="hierarchy.html"><span>Class&nbsp;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&nbsp;Members</span></a></li>
    </ul>
  </div>
  <div class="navpath"><a class="el" href="namespace_sylph.html">Sylph</a>::<a class="el" href="class_sylph_1_1_exception.html">Exception</a>
  </div>
</div>
<div class="contents">
<h1>Sylph::Exception Class Reference</h1><!-- doxytag: class="Sylph::Exception" --><!-- doxytag: inherits="std::exception" -->This class provides a ready-to-use interface for exception handling.  
<a href="#_details">More...</a>
<p>
<code>#include &lt;<a class="el" href="_exception_8h-source.html">Sylph/Core/Exception.h</a>&gt;</code>
<p>
<div class="dynheader">
Inheritance diagram for Sylph::Exception:</div>
<div class="dynsection">
<p><center><img src="class_sylph_1_1_exception__inherit__graph.png" border="0" usemap="#_sylph_1_1_exception__inherit__map" alt="Inheritance graph"></center>
<map name="_sylph_1_1_exception__inherit__map">
<area shape="rect" id="node3" href="class_assertion.html" title="Assertion" alt="" coords="268,5,351,35"><area shape="rect" id="node5" href="class_sylph_1_1_array_exception.html" title="A generic Exception when an error occurs with an Array." alt="" coords="225,59,393,88"><area shape="rect" id="node7" href="class_sylph_1_1_file_exception.html" title="A genreric Exception which gets thrown whenever something goes wrong in the File..." alt="" coords="231,112,388,141"><area shape="rect" id="node9" href="class_sylph_1_1_illegal_argument_exception.html" title="Generic exception to flag an argument with an illegal state was passed to an function..." alt="" coords="189,165,429,195"><area shape="rect" id="node11" href="class_sylph_1_1_illegal_state_exception.html" title="Generic exception to flag that a method is not supported in the current state of..." alt="" coords="204,219,415,248"><area shape="rect" id="node13" href="class_sylph_1_1_i_o_exception.html" title="This is a generic exception for I/O errors." alt="" coords="235,272,384,301"><area shape="rect" id="node15" href="class_sylph_1_1_null_pointer_exception.html" title="This Exception gets thrown when a pointer to null is passed to a function or method..." alt="" coords="205,325,413,355"><area shape="rect" id="node17" href="class_sylph_1_1_serialization_exception.html" title="This Exception gets thrown if there is a problem with serializing or deserializing..." alt="" coords="201,379,417,408"></map>
<center><font size="2">[<a href="graph_legend.html">legend</a>]</font></center></div>

<p>
<a href="class_sylph_1_1_exception-members.html">List of all members.</a><table border="0" cellpadding="0" cellspacing="0">
<tr><td></td></tr>
<tr><td colspan="2"><br><h2>Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_sylph_1_1_exception.html#0f450c97db441da6ac67dae78388ada5">Exception</a> (const char *r=&quot;&quot;, const char *f=&quot;unknown&quot;, const unsigned int l=0)  throw ()</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Creates a new <a class="el" href="class_sylph_1_1_exception.html" title="This class provides a ready-to-use interface for exception handling.">Exception</a>.  <a href="#0f450c97db441da6ac67dae78388ada5"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_sylph_1_1_exception.html#0a1244e5e39e0c176247e7eca88fd6b2">~Exception</a> ()  throw ()</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Default destructor.  <a href="#0a1244e5e39e0c176247e7eca88fd6b2"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">const char *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_sylph_1_1_exception.html#3b56cc13b4004aa72e7ea86f034f968c">what</a> () const   throw ()</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Returns the reason why this <a class="el" href="class_sylph_1_1_exception.html" title="This class provides a ready-to-use interface for exception handling.">Exception</a> was thrown, i.e. the second parameter to <code>sthrow()</code>.  <a href="#3b56cc13b4004aa72e7ea86f034f968c"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual const char *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_sylph_1_1_exception.html#16528d47441cf5ffb45bcdbd119d1661">name</a> () const   throw ()</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Returns the class name of this <a class="el" href="class_sylph_1_1_exception.html" title="This class provides a ready-to-use interface for exception handling.">Exception</a>.  <a href="#16528d47441cf5ffb45bcdbd119d1661"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_sylph_1_1_exception.html#1038e3fb0e96d4733beb0ea03c4aad04">addTraceMessage</a> (const char *message) const   throw ()</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">This function adds a message to the trace information inside this <a class="el" href="class_sylph_1_1_exception.html" title="This class provides a ready-to-use interface for exception handling.">Exception</a>.  <a href="#1038e3fb0e96d4733beb0ea03c4aad04"></a><br></td></tr>
</table>
<hr><a name="_details"></a><h2>Detailed Description</h2>
This class provides a ready-to-use interface for exception handling. 
<p>
Several macros are provided to make using this <a class="el" href="class_sylph_1_1_exception.html" title="This class provides a ready-to-use interface for exception handling.">Exception</a> class easier. An example is the <code>sthrow()</code> macro, which is designed to replace the normal <code>throw</code> keywoard. <pre>void Foo::foobar(const Bar &amp; bar) {
     if(bar.myint &lt; 0)
        sthrow(<a class="el" href="class_sylph_1_1_illegal_argument_exception.html" title="Generic exception to flag an argument with an illegal state was passed to an function...">IllegalArgumentException</a>,
           "Cannot foobar() when Bar::myint &lt; 0");
     else {
       // ...
     }
 }</pre> <code>sthrow</code> adds certain debug information, i.e. file and line numbers, if compilation with the debug flag (<code>-DSYLPH_DEBUG</code>) is enabled. Therefore one should prefer <code>sthrow()</code> over <code> throw</code><p>
To create your own <a class="el" href="class_sylph_1_1_exception.html" title="This class provides a ready-to-use interface for exception handling.">Exception</a> class, use the <code>S_CREATE_EXCEPTION(</code><em>Name</em><code>)</code> macro. This will ensure that everything that is required is in your exception. A new class with name '<em>Name</em>' will be created in the current scope. It extends <a class="el" href="class_sylph_1_1_exception.html" title="This class provides a ready-to-use interface for exception handling.">Sylph::Exception</a>, therefore you can catch all exceptions created with this macro through <code>catch(const Exception&amp; ex)</code>. <p>
Two other macros are defined as well, namely <code>strace</code> and <code>straced</code>. These allow you to add trace information to an <a class="el" href="class_sylph_1_1_exception.html" title="This class provides a ready-to-use interface for exception handling.">Exception</a> (i.e. the name of the current function). An example is given below: <pre>
 void foobar() {
     try {
        someDangerousFunction();
     } strace;
 }
 </pre> <code>straced</code> works similar to <code>strace</code>, but only works when debug mode (<code>-DSYLPH_DEBUG</code>) is enabled.<p>
Two other useful macros are defined, <code>if_nullptr()</code> and <code> check_nullptr()</code>. <code>if_nullptr()</code> works similar to a normal <code>if</code>, but the statements block is only executed when the pointer passed is <code>null</code>. However, this macro is more optimized than a normal if. <code>check_nullptr()</code> works similar, but instead of executing a block of code, it will immeadiately throw an <a class="el" href="class_sylph_1_1_null_pointer_exception.html" title="This Exception gets thrown when a pointer to null is passed to a function or method...">NullPointerException</a>. <hr><h2>Constructor &amp; Destructor Documentation</h2>
<a class="anchor" name="0f450c97db441da6ac67dae78388ada5"></a><!-- doxytag: member="Sylph::Exception::Exception" ref="0f450c97db441da6ac67dae78388ada5" args="(const char *r=&quot;&quot;, const char *f=&quot;unknown&quot;, const unsigned int l=0)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">Sylph::Exception::Exception           </td>
          <td>(</td>
          <td class="paramtype">const char *&nbsp;</td>
          <td class="paramname"> <em>r</em> = <code>&quot;&quot;</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&nbsp;</td>
          <td class="paramname"> <em>f</em> = <code>&quot;unknown&quot;</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const unsigned int&nbsp;</td>
          <td class="paramname"> <em>l</em> = <code>0</code></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td>  throw ()<code> [inline]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Creates a new <a class="el" href="class_sylph_1_1_exception.html" title="This class provides a ready-to-use interface for exception handling.">Exception</a>. 
<p>
You should not use this directly, instead, use <code>sthrow()</code> <dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>r</em>&nbsp;</td><td>The reason why this <a class="el" href="class_sylph_1_1_exception.html" title="This class provides a ready-to-use interface for exception handling.">Exception</a> got thrown. This is the second parameter to <code>sthrow()</code>. </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>f</em>&nbsp;</td><td>The file this <a class="el" href="class_sylph_1_1_exception.html" title="This class provides a ready-to-use interface for exception handling.">Exception</a> got thrown in. This will automatically be filled in by <code>sthrow()</code> if the macro <code>SYLPH_DEBUG</code> is defined, else it defaults to the string "unknown". </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>l</em>&nbsp;</td><td>The line number on which this <a class="el" href="class_sylph_1_1_exception.html" title="This class provides a ready-to-use interface for exception handling.">Exception</a> got thrown. This will automatically be filled in by <code>sthrow()</code> if the macro <code>SYLPH_DEBUG</code> is defined, else it defaults to 0. </td></tr>
  </table>
</dl>

</div>
</div><p>
<a class="anchor" name="0a1244e5e39e0c176247e7eca88fd6b2"></a><!-- doxytag: member="Sylph::Exception::~Exception" ref="0a1244e5e39e0c176247e7eca88fd6b2" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual Sylph::Exception::~Exception           </td>
          <td>(</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td>  throw ()<code> [inline, virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Default destructor. 
<p>
Frees the memory used by the trace info. If this <a class="el" href="class_sylph_1_1_exception.html" title="This class provides a ready-to-use interface for exception handling.">Exception</a> contains to trace info, this destructor does nothing. 
</div>
</div><p>
<hr><h2>Member Function Documentation</h2>
<a class="anchor" name="1038e3fb0e96d4733beb0ea03c4aad04"></a><!-- doxytag: member="Sylph::Exception::addTraceMessage" ref="1038e3fb0e96d4733beb0ea03c4aad04" args="(const char *message) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Sylph::Exception::addTraceMessage           </td>
          <td>(</td>
          <td class="paramtype">const char *&nbsp;</td>
          <td class="paramname"> <em>message</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td> const  throw ()<code> [inline]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
This function adds a message to the trace information inside this <a class="el" href="class_sylph_1_1_exception.html" title="This class provides a ready-to-use interface for exception handling.">Exception</a>. 
<p>
It can be useful to add the name of a function the <a class="el" href="class_sylph_1_1_exception.html" title="This class provides a ready-to-use interface for exception handling.">Exception</a> passes through (i.e. what <code>strace</code> does), or any other information you like to add to the <a class="el" href="class_sylph_1_1_exception.html" title="This class provides a ready-to-use interface for exception handling.">Exception</a>. This information is purely diagnostic. <dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>message</em>&nbsp;</td><td>The message to add in the traceinfo log. </td></tr>
  </table>
</dl>

</div>
</div><p>
<a class="anchor" name="16528d47441cf5ffb45bcdbd119d1661"></a><!-- doxytag: member="Sylph::Exception::name" ref="16528d47441cf5ffb45bcdbd119d1661" args="() const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual const char* Sylph::Exception::name           </td>
          <td>(</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td> const  throw ()<code> [inline, virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Returns the class name of this <a class="el" href="class_sylph_1_1_exception.html" title="This class provides a ready-to-use interface for exception handling.">Exception</a>. 
<p>
If you used the <code> S_CREATE_EXCEPTION(</code><em>name</em><code>)</code> macro, this will be automatically filled in for you. Otherwise you'll have to put in the name yourself. This is purely diagnostic information. <dl class="return" compact><dt><b>Returns:</b></dt><dd>The name of the class of this <a class="el" href="class_sylph_1_1_exception.html" title="This class provides a ready-to-use interface for exception handling.">Exception</a>. </dd></dl>

<p>Reimplemented in <a class="el" href="class_assertion.html#0f84db344ea67d9084fa450af0e2261e">Assertion</a>, <a class="el" href="class_sylph_1_1_array_exception.html#a08a8b44fe9a17a7d49fbf7901337da1">Sylph::ArrayException</a>, <a class="el" href="class_sylph_1_1_file_exception.html#ed1e2488c6e6546ae805eeef2c0c166b">Sylph::FileException</a>, <a class="el" href="class_sylph_1_1_i_o_exception.html#3fbf12448999e9e0b68a1c3bbd36a742">Sylph::IOException</a>, <a class="el" href="class_sylph_1_1_illegal_argument_exception.html#32f8fb7f6fc25f97a82053face9304e8">Sylph::IllegalArgumentException</a>, <a class="el" href="class_sylph_1_1_illegal_state_exception.html#8e46190d7b17a2f8b62c4dd51ef83508">Sylph::IllegalStateException</a>, <a class="el" href="class_sylph_1_1_null_pointer_exception.html#a2dce7a7d789fe26a2de523bdf0358f2">Sylph::NullPointerException</a>, and <a class="el" href="class_sylph_1_1_serialization_exception.html#644a24bfe9e0d21c368155324d9ae33f">Sylph::SerializationException</a>.</p>

</div>
</div><p>
<a class="anchor" name="3b56cc13b4004aa72e7ea86f034f968c"></a><!-- doxytag: member="Sylph::Exception::what" ref="3b56cc13b4004aa72e7ea86f034f968c" args="() const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">const char* Sylph::Exception::what           </td>
          <td>(</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td> const  throw ()<code> [inline]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Returns the reason why this <a class="el" href="class_sylph_1_1_exception.html" title="This class provides a ready-to-use interface for exception handling.">Exception</a> was thrown, i.e. the second parameter to <code>sthrow()</code>. 
<p>
<dl class="return" compact><dt><b>Returns:</b></dt><dd>The reason why this <a class="el" href="class_sylph_1_1_exception.html" title="This class provides a ready-to-use interface for exception handling.">Exception</a> was thrown. </dd></dl>

</div>
</div><p>
</div>
<hr size="1" class="unhidden"><address style="text-align: right;"><small>
Documentation for LibSylph by Doxygen
</body>
</html>
